"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports._coercePrivateKey = exports.coercePrivateKey = void 0;
var _crypto_1 = require("./_crypto");
var create_key_pair_1 = require("./create_key_pair");
var crypto_1 = require("crypto");
var crypto = (0, _crypto_1.getCrypto)();
var doDebug = false;
function coercePrivateKey(privateKey) {
    if (typeof privateKey === "string") {
        return (0, crypto_1.createPrivateKey)(privateKey);
    }
    return privateKey;
}
exports.coercePrivateKey = coercePrivateKey;
function _coercePrivateKey(privateKey) {
    return __awaiter(this, void 0, void 0, function () {
        var KeyObject, privateKey1, privateKey1, err_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    KeyObject = crypto.KeyObject;
                    if (!(privateKey instanceof Buffer)) return [3, 2];
                    return [4, (0, create_key_pair_1.derToPrivateKey)(privateKey)];
                case 1:
                    privateKey1 = _a.sent();
                    return [2, KeyObject.from(privateKey1)];
                case 2:
                    if (!(typeof privateKey === "string")) return [3, 7];
                    _a.label = 3;
                case 3:
                    _a.trys.push([3, 5, , 6]);
                    return [4, (0, create_key_pair_1.pemToPrivateKey)(privateKey)];
                case 4:
                    privateKey1 = _a.sent();
                    return [2, KeyObject.from(privateKey1)];
                case 5:
                    err_1 = _a.sent();
                    doDebug && console.log(privateKey);
                    throw err_1;
                case 6: return [3, 8];
                case 7:
                    if (privateKey instanceof KeyObject) {
                        return [2, privateKey];
                    }
                    _a.label = 8;
                case 8: throw new Error("Invalid privateKey");
            }
        });
    });
}
exports._coercePrivateKey = _coercePrivateKey;
//# sourceMappingURL=coerce_private_key.js.map